//#include "StdAfx.h"
#include ".\aboutbox.h"
#include "Resource.h"
#define _BLADEDLL
#include "BladeMP3EncDLL.h"
#include <StdIO.h>

CAboutBox::CAboutBox(HWND hParent)
{
	hPrntWnd=hParent;
}

CAboutBox::~CAboutBox(void)
{
}

int CAboutBox::ShowModal()
{
	return (int)DialogBoxParam(GetModuleHandle(NULL),MAKEINTRESOURCE(IDD_DLG_ABOUT),hPrntWnd,(DLGPROC)stAboutProc,(LPARAM)this);
}

LRESULT CALLBACK CAboutBox::stAboutProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	static CAboutBox *pThis=NULL;
	if(uMsg==WM_INITDIALOG)
	{
		pThis=(CAboutBox*)lParam;
	}
	if (pThis!=NULL) return pThis->AboutProc(hDlg,uMsg,wParam,lParam);
	return FALSE;
}

LRESULT CALLBACK CAboutBox::AboutProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	switch(uMsg)
	{
		case WM_INITDIALOG:
			OnInitDialog(hDlg);
			return TRUE;
		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
	}
	return FALSE;
}

void CAboutBox::CenterOnParent(HWND hDlg)
{
	RECT rcDlg,rcPrnt;
	int x,y;
	GetWindowRect(hDlg,&rcDlg);
	GetWindowRect(hPrntWnd,&rcPrnt);
	x=rcPrnt.left+(((rcPrnt.right-rcPrnt.left)-(rcDlg.right-rcDlg.left))/2);
	y=rcPrnt.top+(((rcPrnt.bottom-rcPrnt.top)-(rcDlg.bottom-rcDlg.top))/2);
	SetWindowPos(hDlg,NULL,x,y,0,0,SWP_NOSIZE|SWP_NOZORDER);
}

void CAboutBox::OnInitDialog(HWND hDlg)
{
	CenterOnParent(hDlg);
	char szTxt[MAX_PATH];
	BE_VERSION Version;
	beVersion(&Version);
	int i;
	i=sprintf(szTxt,"Encodeur : \"lame_enc.dll\" (v%0d,%02d) ",Version.byDLLMajorVersion,Version.byDLLMinorVersion);
	i+=sprintf(szTxt+i,"(moteur v%0d,%02d) %s",Version.byMajorVersion,Version.byMinorVersion,Version.zHomepage);
	SetDlgItemText(hDlg,IDC_LAME_VERSION,szTxt);
}
