#ifndef MP3FILE_H
#define MP3FILE_H
#include <Windows.h>
#include <StdIO.h>
#define _BLADEDLL
#include "BladeMP3EncDLL.h"

class CMP3File
{
public:
	CMP3File(void);
	~CMP3File(void);
	int SetFileName(char *szFName);
	void SetEncodingBitRate(DWORD dwBitrate);
	void SetSourceFormat(WORD wChannels,DWORD dwSmplRate,WORD wBits);
	int EnableVBR(bool bEnable=true);
	int SetVBRMaxBitrate(DWORD dwMax);
	int Create();
	int AddDatas(void *TheDatas,int DataSize);
	int Close();
private:
	char * p_szFName;
	bool p_bIsOpened;
	FILE *f_out;
	float p_fDllVersion,p_fEngineVersion;
	DWORD dwDataSize;
	// Paramtres d'encodage
	DWORD p_dwBitrate,p_dwMaxBitrate,p_dwSampleRate;
	WORD p_wBits; 
	int p_nMode;
	bool p_bEnableVBR;
	//
	BE_CONFIG beConf;
	DWORD dwSmpls;
	DWORD dwMP3Buff;
	HBE_STREAM hbeStrm;
	DWORD dwNRes;
	// Buffers et variables associes
	PBYTE pMP3Buff;
	PBYTE  pTmpBuff;
	int iTmpBuffPos;
};

#endif
